[LeetCode] 218. The Skyline Problem

A city's skyline is the outer contour of the silhouette formed by all the buildings in that city when viewed from a distance. Now suppose you are given the locations and height of all the buildings as shown on a cityscape photo (Figure A), write a program to output the skyline formed by these buildings collectively (Figure B).
Buildings Skyline Contour
The geometric information of each building is represented by a triplet of integers [Li, Ri, Hi], where Li and Ri are the x coordinates of the left and right edge of the ith building, respectively, and Hi is its height. It is guaranteed that 0 ? Li, Ri ? INT_MAX0 < Hi ? INT_MAX, and Ri - Li > 0. You may assume all buildings are perfect rectangles grounded on an absolutely flat surface at height 0.
For instance, the dimensions of all buildings in Figure A are recorded as: [ [2 9 10], [3 7 15], [5 12 12], [15 20 10], [19 24 8] ].
The output is a list of "key points" (red dots in Figure B) in the format of [ [x1,y1], [x2, y2], [x3, y3], ... ] that uniquely defines a skyline. A key point is the left endpoint of a horizontal line segment. Note that the last key point, where the rightmost building ends, is merely used to mark the termination of the skyline, and always has zero height. Also, the ground in between any two adjacent buildings should be considered part of the skyline contour.
For instance, the skyline in Figure B should be represented as:[ [2 10], [3 15], [7 12], [12 0], [15 10], [20 8], [24, 0] ].
Notes:
  • The number of buildings in any input list is guaranteed to be in the range [0, 10000].
  • The input list is already sorted in ascending order by the left x position Li.
  • The output list must be sorted by the x position.
  • There must be no consecutive horizontal lines of equal height in the output skyline. For instance, [...[2 3], [4 5], [7 5], [11 5], [12 7]...] is not acceptable; the three lines of height 5 should be merged into one in the final output as such: [...[2 3], [4 5], [12 7], ...]

Thought process:
The points I need are the top-left or top-right corners of the rectangles. If I split the dimensions given into [left-x, y], [right-x, y] tuples, I got a height map and I can sort it based on x value. But critical points only appear when the skyline's height changes.
The idea is to iterate through the sorted height map. When a new rectangle overlaps with the previous rectangle, it's important to know if the left edge of the new rectangle is higher than current maximum height. A heap can help in this case.
  1. Iterate through a list of coordinates of the left and right corners of the rectangles. When I see a left edge, I put its height into a max heap, and record current max height.
    1. If current max height is different with previous max height, there is a turn in the skyline. Add coordinates[0] and current to result list.
  2. When I see a right edge, I remove that height from the heap, meaning this rectangle is finished.

Solution:

 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
class Solution {
    public List<int[]> getSkyline(int[][] buildings) {
        List<int[]> heights = new ArrayList<>();
        for (int[] building : buildings) {
            heights.add(new int[]{ building[0], -building[2] });
            heights.add(new int[]{ building[1], building[2] });
        }
        heights.sort((a, b) -> a[0] == b[0] ? a[1] - b[1] : a[0] - b[0]);
        
        List<int[]> skyline = new ArrayList<>();
        Queue<Integer> heap = new PriorityQueue<>(Collections.reverseOrder());
        heap.offer(0);
        int previous = 0;
        
        for (int[] height : heights) {
            if (height[1] < 0) {
                heap.offer(-height[1]);
            } else {
                heap.remove(height[1]);
            }
            
            if (heap.peek() != previous) {
                skyline.add(new int[]{ height[0], heap.peek() });
                previous = heap.peek();
            }
        }
        return skyline;
    }
}

Time complexity:
Say the number of buildings is n. Creating height list takes O(n). Sorting it takes O(nlogn). The second for loop can potentially take O(n^2) because PriorityQueue.remove() takes O(n). So the overall time complexity is O(n^2).

Comments

Post a Comment

Popular posts from this blog

[LeetCode] 269. Alien Dictionary

[HackerRank] Roads and Libraries

[LeetCode] 631. Design Excel Sum Formula